/* example 2 for simulation with SPIN */
/* non-deterministic case selection */

#define FOO 100
#define BAR 200

chan ch = [1] of {int};

proctype A() { 
    if
    :: ch!FOO
    :: ch!BAR
    fi
}

proctype B() {
    if
    :: ch?FOO -> printf("integer received : %d\n",FOO)
    :: ch?BAR -> printf("integer received : %d\n",BAR)
    fi
}

init { run A(); run B() }

